#include "blikedrv.h"
#include <windows.h>
#include <setjmp.h>

struct BLD_WORK {
	jmp_buf jb;
	HINSTANCE hi;
	HWND hw;
	BITMAPINFO bmi;
};

static struct BLD_WORK dw;

#define w	bl_work

void bld_openWin(int x, int y);
void bld_flshWin(int sx, int sy, int x0, int y0);
int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR pCmdLine, int showCmd);
LRESULT CALLBACK WndProc(HWND hw, unsigned int msg, WPARAM wp, LPARAM lp);
void bld_waitNF(int msec);
void bld_exit();

void bld_openWin(int x, int y)
{
	WNDCLASSEX wc;
	RECT rect;

	dw.bmi.bmiHeader.biSize = sizeof (BITMAPINFOHEADER);
	dw.bmi.bmiHeader.biWidth = x;
	dw.bmi.bmiHeader.biHeight = - y;
	dw.bmi.bmiHeader.biPlanes = 1;
	dw.bmi.bmiHeader.biBitCount = 32;
	dw.bmi.bmiHeader.biCompression = BI_RGB;

	wc.cbSize = sizeof (WNDCLASSEX);
	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = WndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = dw.hi;
	wc.hIcon = (HICON) LoadImage(NULL, MAKEINTRESOURCE(IDI_APPLICATION),
		IMAGE_ICON, 0, 0, LR_DEFAULTSIZE | LR_SHARED);
	wc.hIconSm = wc.hIcon;
	wc.hCursor = (HCURSOR)LoadImage(NULL, MAKEINTRESOURCE(IDC_ARROW),
		IMAGE_CURSOR, 0, 0, LR_DEFAULTSIZE | LR_SHARED);
	wc.hbrBackground = (HBRUSH) COLOR_APPWORKSPACE;
	wc.lpszMenuName = NULL;
	wc.lpszClassName = "WinClass";
	if (RegisterClassEx(&wc) == 0)
		return;

	dw.hw = CreateWindowA(wc.lpszClassName, "blike-app", WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT, CW_USEDEFAULT, x, y, NULL, NULL,	dw.hi, NULL);
	if (dw.hw == NULL)
		return;
	rect.left = 0;
	rect.top = 0;
	rect.right = x;
	rect.bottom = y;
	AdjustWindowRect(&rect, wc.style, 0);
	ShowWindow(dw.hw, SW_SHOW);
	UpdateWindow(dw.hw);
	return;
}

void bld_flshWin(int sx, int sy, int x0, int y0)
{
	RECT rect;
	rect.left = x0;
	rect.top = y0;
	rect.right = x0 + sx - 1;
	rect.bottom = y0 + sy - 1;
	if (dw.hw != NULL)
		InvalidateRect(dw.hw, &rect, FALSE);
	return;
}

int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR pCmdLine, int showCmd)
{
	dw.hi = hInst;
	bl_init();
	if (setjmp(dw.jb) == 0)
		blMain();
	PostQuitMessage(0);
	bl_exit();
	return 0;
}

LRESULT CALLBACK WndProc(HWND hw, unsigned int msg, WPARAM wp, LPARAM lp)
{
	if (msg == WM_PAINT) {
		PAINTSTRUCT ps;
		HDC hdc = BeginPaint(dw.hw, &ps);
		SetDIBitsToDevice(hdc, 0, 0, w.wsiz_x, w.wsiz_y, 0, 0, 0, w.wsiz_y,
			w.gbuf, &dw.bmi, DIB_RGB_COLORS);
		EndPaint(dw.hw, &ps);
	}
	if (msg == WM_DESTROY) {
		PostQuitMessage(0);
		return 0;
	}
	return DefWindowProc(hw, msg, wp, lp);
}

void bld_waitNF(int msec)
{
	MSG msg;
	int i;

	i = PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE);
	if (i == 0 && msec != -1) return;
	for (;;) {
		i = GetMessage(&msg, NULL, 0, 0);
		if (i == 0 || i == -1)	/* G[͏IbZ[W */
			bld_exit();
		/* ̂ق͂Ƃ肠ftHg */
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
}

void bld_exit()
{
	bl_exit();
	longjmp(dw.jb, 1);
}

